#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: shob.pleaf.m4,v 1.3 2022/08/20 19:20:18 babolo Exp $
#

eval
#style   00y001
shob
#select  _002
SELECT ( (SQNM(sessb).SQAT(sess) * SQNM(cipaconf).SQAT(a3))
       + SQNM(cipaconf).SQAT(a2)
       ) % SQNM(cipaconf).SQAT(a1)                                             AS sess
     , SQNM(sessb).SQAT(cnt)                                                   AS cnt
     , SQNM(sessb).SQAT(srcip)                                                 AS srcip
     , SQNM(sessb).SQAT(ttl)                                                   AS ttl
     , CASE WHEN SQNM(sessb).SQAT(flags) & SessClaimPass THEN 'g' ELSE 'r' END AS "SCP"
     , CASE WHEN SQNM(sessb).SQAT(flags) & SessAuthName  THEN 'g' ELSE 'r' END AS "SAN"
     , datetime( SQNM(sessb).SQAT(created)
               , 'unixepoch'
               , CAST(COALESCE(SQNM(sess).SQAT(hzone)
                              , SQNM(pass).SQAT(hzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' hours'
               , CAST(COALESCE(SQNM(sess).SQAT(mzone)
                              , SQNM(pass).SQAT(mzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' minutes'
               )                                                               AS created
     , datetime( NULLIF(SQNM(sessb).SQAT(updated), 0)
               , 'unixepoch'
               , CAST(COALESCE(SQNM(sess).SQAT(hzone)
                              , SQNM(pass).SQAT(hzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' hours'
               , CAST(COALESCE(SQNM(sess).SQAT(mzone)
                              , SQNM(pass).SQAT(mzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' minutes'
               )                                                               AS updated
     , datetime( SQNM(sessb).SQAT(removed)
               , 'unixepoch'
               , CAST(COALESCE(SQNM(sess).SQAT(hzone)
                              , SQNM(pass).SQAT(hzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' hours'
               , CAST(COALESCE(SQNM(sess).SQAT(mzone)
                              , SQNM(pass).SQAT(mzone)
                              , 0
                              )
                      AS TEXT
                     ) || ' minutes'
               )                                                               AS removed
 FROM  SQNM(x)
  JOIN SQNM(sess)  USING(SQAT(cred), SQAT(sess))
  JOIN SQNM(pass)  USING(SQAT(cred))
  JOIN SQNM(sessb) USING(SQAT(cred))
    ,  SQNM(cipaconf)
 WHERE SQNM(x).SQAT(cred) > 0
   AND SQNM(sessb).SQAT(removed) > (SQNM(x).SQAT(b) - COALESCE(SQNM(x).SQAT(m), 259200))
ORDER BY SQNM(sessb).SQAT(removed) DESC
;
#display 00_001
#close   _0_001
